<?php
class ControllerExtensionPaymentSenangpay extends Controller
{
    public function index()
    {
        $data['button_confirm'] = $this->language->get('button_confirm');

        $data['continue'] = $this->url->link('checkout/success');
        
        # Prepare the data to send to senangPay
        $data['senangpay_url'] = 'https://app.senangpay.my/payment/'.$this->config->get('payment_senangpay_merchant_id');
        $data['senangpay_order_id'] = $this->session->data['order_id'];
        $data['senangpay_detail'] = "Payment_for_order_".$this->session->data['order_id'];
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $data['senangpay_amount'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
        # need to strip the $ and comma
        $data['senangpay_amount'] = str_replace('$', '', $data['senangpay_amount']);
        $data['senangpay_amount'] = str_replace(',', '', $data['senangpay_amount']);
        $data['senangpay_hash'] = md5($this->config->get('payment_senangpay_secret_key').$data['senangpay_detail'].$data['senangpay_amount'].$this->session->data['order_id']);

        if ($this->customer->isLogged()) {
            $name = $this->customer->getFirstName().' '.$this->customer->getLastName();
            $email = $this->customer->getEmail();
            $phone = $this->customer->getTelephone();
        } elseif (isset($this->session->data['guest'])) {
            $name = $this->session->data['guest']['firstname'] . ' ' . $this->session->data['guest']['lastname'];
            $email = $this->session->data['guest']['email'];
            $phone = $this->session->data['guest']['telephone'];
        } else {
            $name = '';
            $email = '';
            $phone = '';
        }

        $data['senangpay_customer_name'] = $name;
        $data['senangpay_email'] = $email;
        $data['senangpay_phone'] = $phone;

        return $this->load->view('extension/payment/senangpay', $data);
    }
    
    public function callback()
    {
        $this->load->language('extension/payment/senangpay');
        $this->document->setTitle($this->language->get('text_payment_title'));
        
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['content_top'] = $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');
      
        $transaction_status = false;
        if(isset($this->request->get['status_id']) && isset($this->request->get['order_id']) && isset($this->request->get['msg']) && isset($this->request->get['transaction_id']) && isset($this->request->get['hash']))
        {
            $status_id = urldecode($this->request->get['status_id']);
            $order_id = urldecode($this->request->get['order_id']);
            $msg = urldecode($this->request->get['msg']);
            $transaction_id = urldecode($this->request->get['transaction_id']);
            $hash = urldecode($this->request->get['hash']);
            
            $this->load->model('checkout/order');
            $order_info = $this->model_checkout_order->getOrder($order_id);
            if($order_info)
            {
                $hash_value = md5($this->config->get('payment_senangpay_secret_key').$status_id.$order_id.$transaction_id.$msg);
                if($hash_value == $hash)
                {
                    if($status_id == '1' || $status_id == 1)
                    {
                        $transaction_status = true;
                        $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_senangpay_order_status_id'), 'Payment was made using senangPay. senangPay transaction id is '.$transaction_id, false);
                        if($this->cart->hasProducts())
                            $this->cart->clear();
                    }
                }
            }
        }
        
        if(!$transaction_status)
        {
            $data['checkout_link'] = $this->url->link('checkout/checkout', '', true);
            $this->response->setOutput($this->load->view('extension/payment/senangpay_failed', $data));
        }
        else
            $this->response->redirect($this->url->link('checkout/success', '', true));
    }
    
    public function callback_response()
    {
        if(isset($this->request->post['status_id']) && isset($this->request->post['order_id']) && isset($this->request->post['msg']) && isset($this->request->post['transaction_id']) && isset($this->request->post['hash']))
        {
            $status_id = urldecode($this->request->post['status_id']);
            $order_id = urldecode($this->request->post['order_id']);
            $msg = urldecode($this->request->post['msg']);
            $transaction_id = urldecode($this->request->post['transaction_id']);
            $hash = urldecode($this->request->post['hash']);
            
            $this->load->model('checkout/order');
            $order_info = $this->model_checkout_order->getOrder($order_id);
            if($order_info)
            {
                if($order_info['order_status_id'] != $this->config->get('payment_senangpay_order_status_id'))
                {
                    $hash_value = md5($this->config->get('payment_senangpay_secret_key').$status_id.$order_id.$transaction_id.$msg);
                    if($hash_value == $hash)
                    {
                        if($status_id == '1' || $status_id == 1)
                        {
                            $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_senangpay_order_status_id'), 'Payment was made using senangPay. senangPay transaction id is '.$transaction_id, false);
                            if($this->cart->hasProducts())
                                $this->cart->clear();
                        }
                    }
                }
            }

            // Always return OK
            $this->response->setOutput('OK');
        }
    }
}